<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>3.6 <TT>break</TT> and <TT>continue</TT></title>
<link href="sx3e.html" rev=precedes>
<link href="sx4.html" rel=precedes>
<link href="sx3.html" rev=subdocument>
</head>
<body>
<H2>3.6 <TT>break</TT> and <TT>continue</TT></H2>

<p>[This section corresponds to K&amp;R Sec. 3.7]
</p><p>Sometimes, due to an exceptional condition, you need to jump
out of a loop early, that is, before the main controlling
expression of the loop causes it to terminate normally.
Other times, in an elaborate loop, you may want to jump back to
the top of the loop
(to test the controlling expression again, and perhaps begin a
new trip through the loop)
without playing out all the steps of the current loop.
The <TT>break</TT> and <TT>continue</TT> statements allow you to do
these two things.
(They are, in fact, essentially restricted forms of <TT>goto</TT>.)
</p><p>To put everything we've seen in this chapter together,
as well as demonstrate
the use of the
<TT>break</TT> statement,
here is a program for printing prime numbers between 1 and 100:
<pre>
#include &lt;stdio.h&gt;
#include &lt;math.h&gt;

main()
{
int i, j;

printf("%d\n", 2);

for(i = 3; i &lt;= 100; i = i + 1)
	{
	for(j = 2; j &lt; i; j = j + 1)
		{
		if(i % j == 0)
			break;
		if(j &gt; sqrt(i))
			{
			printf("%d\n", i);
			break;
			}
		}
	}

return 0;
}
</pre>
The outer loop steps the variable <TT>i</TT> through
the numbers from 3 to 100;
the code tests
to see if each number has
any divisors other than 1 and itself.
The trial divisor <TT>j</TT> loops from 2 up to <TT>i</TT>.
<TT>j</TT> is a divisor of <TT>i</TT>
if the remainder of <TT>i</TT> divided by <TT>j</TT> is 0,
so the code uses C's ``remainder'' or ``modulus''
operator <TT>%</TT> to make this test.
(Remember that <TT>i % j</TT> gives the remainder 
when <TT>i</TT> is divided by <TT>j</TT>.)
</p><p>If the program finds a divisor, it uses <TT>break</TT> to 
break out of the inner loop, without printing anything.
But if it notices that <TT>j</TT> has risen higher than the 
square root of <TT>i</TT>, without its having found any 
divisors, then <TT>i</TT> must not have any divisors, so 
<TT>i</TT> is prime, and its value is printed.
(Once we've determined that <TT>i</TT> is prime by noticing 
that <TT>j &gt; sqrt(i)</TT>,
there's no need to try the other trial divisors, so we use a 
second <TT>break</TT> statement to break out of the loop in 
that case, too.)
</p><p>The simple algorithm and implementation we used
here
(like many simple prime number algorithms)
does not work for 2, the only even prime number,
so the program ``cheats'' and prints out 2 no matter 
what, before going on to test the numbers from 3 to 100.
</p><p>Many improvements to this simple program are of course possible;

you might experiment with it.
(Did you notice that the ``test'' expression of the 
inner loop
<TT>for(j = 2; j &lt; i; j = j + 1)</TT>
is in a sense unnecessary,
because the loop always terminates early
due to one of the two <TT>break</TT> statements?)

</p><hr>
<p>
Read sequentially:
<a href="sx3e.html" rev=precedes>prev</a>
<a href="sx4.html" rel=precedes>next</a>
<a href="sx3.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
